/* Generated by ./dbus-analyze-types.py.  Do not edit! */
typedef enum
{
	GAIM_BLIST_GROUP_NODE,
	GAIM_BLIST_CONTACT_NODE,
	GAIM_BLIST_BUDDY_NODE,
	GAIM_BLIST_CHAT_NODE,
	GAIM_BLIST_OTHER_NODE

} GaimBlistNodeType;

typedef enum
{
	GAIM_BLIST_NODE_FLAG_NO_SAVE = 1 /**< node should not be saved with the buddy list */

} GaimBlistNodeFlags;

typedef enum _GaimCipherCaps {
	GAIM_CIPHER_CAPS_SET_OPT			= 1 << 1,		/**< Set option flag	*/
	GAIM_CIPHER_CAPS_GET_OPT			= 1 << 2,		/**< Get option flag	*/
	GAIM_CIPHER_CAPS_INIT				= 1 << 3,		/**< Init flag			*/
	GAIM_CIPHER_CAPS_RESET				= 1 << 4,		/**< Reset flag			*/
	GAIM_CIPHER_CAPS_UNINIT				= 1 << 5,		/**< Uninit flag		*/
	GAIM_CIPHER_CAPS_SET_IV				= 1 << 6,		/**< Set IV flag		*/
	GAIM_CIPHER_CAPS_APPEND				= 1 << 7,		/**< Append flag		*/
	GAIM_CIPHER_CAPS_DIGEST				= 1 << 8,		/**< Digest flag		*/
	GAIM_CIPHER_CAPS_ENCRYPT			= 1 << 9,		/**< Encrypt flag		*/
	GAIM_CIPHER_CAPS_DECRYPT			= 1 << 10,		/**< Decrypt flag		*/
	GAIM_CIPHER_CAPS_SET_SALT			= 1 << 11,		/**< Set salt flag		*/
	GAIM_CIPHER_CAPS_GET_SALT_SIZE		= 1 << 12,		/**< Get salt size flag	*/
	GAIM_CIPHER_CAPS_SET_KEY			= 1 << 13,		/**< Set key flag		*/
	GAIM_CIPHER_CAPS_GET_KEY_SIZE		= 1 << 14,		/**< Get key size flag	*/
	GAIM_CIPHER_CAPS_UNKNOWN			= 1 << 16		/**< Unknown			*/
} GaimCipherCaps;

typedef enum _GaimCmdPriority GaimCmdPriority;

typedef enum _GaimCmdFlag     GaimCmdFlag;

typedef enum _GaimCmdStatus   GaimCmdStatus;

typedef enum _GaimCmdRet      GaimCmdRet;

enum _GaimCmdStatus {
	GAIM_CMD_STATUS_OK,
	GAIM_CMD_STATUS_FAILED,
	GAIM_CMD_STATUS_NOT_FOUND,
	GAIM_CMD_STATUS_WRONG_ARGS,
	GAIM_CMD_STATUS_WRONG_PRPL,
	GAIM_CMD_STATUS_WRONG_TYPE,
};

enum _GaimCmdRet {
	GAIM_CMD_RET_OK,       /**< Everything's okay. Don't look for another command to call. */
	GAIM_CMD_RET_FAILED,   /**< The command failed, but stop looking.*/
	GAIM_CMD_RET_CONTINUE, /**< Continue, looking for other commands with the same name to call. */
};

enum _GaimCmdPriority {
	GAIM_CMD_P_VERY_LOW  = -1000,
	GAIM_CMD_P_LOW       =     0,
	GAIM_CMD_P_DEFAULT   =  1000,
	GAIM_CMD_P_PRPL      =  2000,
	GAIM_CMD_P_PLUGIN    =  3000,
	GAIM_CMD_P_ALIAS     =  4000,
	GAIM_CMD_P_HIGH      =  5000,
	GAIM_CMD_P_VERY_HIGH =  6000,
};

enum _GaimCmdFlag {
	GAIM_CMD_FLAG_IM               = 0x01,
	GAIM_CMD_FLAG_CHAT             = 0x02,
	GAIM_CMD_FLAG_PRPL_ONLY        = 0x04,
	GAIM_CMD_FLAG_ALLOW_WRONG_ARGS = 0x08,
};

typedef enum
{
	GAIM_CONNECTION_HTML       = 0x0001, /**< Connection sends/receives in 'HTML'. */
	GAIM_CONNECTION_NO_BGCOLOR = 0x0002, /**< Connection does not send/receive
					           background colors.                  */
	GAIM_CONNECTION_AUTO_RESP  = 0x0004,  /**< Send auto responses when away.       */
	GAIM_CONNECTION_FORMATTING_WBFO = 0x0008, /**< The text buffer must be formatted as a whole */
	GAIM_CONNECTION_NO_NEWLINES = 0x0010, /**< No new lines are allowed in outgoing messages */
	GAIM_CONNECTION_NO_FONTSIZE = 0x0020, /**< Connection does not send/receive font sizes */
	GAIM_CONNECTION_NO_URLDESC = 0x0040,  /**< Connection does not support descriptions with links */
	GAIM_CONNECTION_NO_IMAGES = 0x0080,  /**< Connection does not support sending of images */

} GaimConnectionFlags;

typedef enum
{
	GAIM_DISCONNECTED = 0, /**< Disconnected. */
	GAIM_CONNECTED,        /**< Connected.    */
	GAIM_CONNECTING        /**< Connecting.   */

} GaimConnectionState;

typedef enum
{
	GAIM_CONV_TYPE_UNKNOWN = 0, /**< Unknown conversation type. */
	GAIM_CONV_TYPE_IM,          /**< Instant Message.           */
	GAIM_CONV_TYPE_CHAT,        /**< Chat room.                 */
	GAIM_CONV_TYPE_MISC,        /**< A misc. conversation.      */
	GAIM_CONV_TYPE_ANY          /**< Any type of conversation.  */

} GaimConversationType;

typedef enum
{
	GAIM_CONV_UPDATE_ADD = 0, /**< The buddy associated with the conversation
	                               was added.   */
	GAIM_CONV_UPDATE_REMOVE,  /**< The buddy associated with the conversation
	                               was removed. */
	GAIM_CONV_UPDATE_ACCOUNT, /**< The gaim_account was changed. */
	GAIM_CONV_UPDATE_TYPING,  /**< The typing state was updated. */
	GAIM_CONV_UPDATE_UNSEEN,  /**< The unseen state was updated. */
	GAIM_CONV_UPDATE_LOGGING, /**< Logging for this conversation was
	                               enabled or disabled. */
	GAIM_CONV_UPDATE_TOPIC,   /**< The topic for a chat was updated. */
	/*
	 * XXX These need to go when we implement a more generic core/UI event
	 * system.
	 */
	GAIM_CONV_ACCOUNT_ONLINE,  /**< One of the user's accounts went online.  */
	GAIM_CONV_ACCOUNT_OFFLINE, /**< One of the user's accounts went offline. */
	GAIM_CONV_UPDATE_AWAY,     /**< The other user went away.                */
	GAIM_CONV_UPDATE_ICON,     /**< The other user's buddy icon changed.     */
	GAIM_CONV_UPDATE_TITLE,
	GAIM_CONV_UPDATE_CHATLEFT,

	GAIM_CONV_UPDATE_FEATURES, /**< The features for a chat have changed */

} GaimConvUpdateType;

typedef enum
{
	GAIM_NOT_TYPING = 0,  /**< Not typing.                 */
	GAIM_TYPING,          /**< Currently typing.           */
	GAIM_TYPED            /**< Stopped typing momentarily. */

} GaimTypingState;

typedef enum
{
	GAIM_MESSAGE_SEND        = 0x0001, /**< Outgoing message.        */
	GAIM_MESSAGE_RECV        = 0x0002, /**< Incoming message.        */
	GAIM_MESSAGE_SYSTEM      = 0x0004, /**< System message.          */
	GAIM_MESSAGE_AUTO_RESP   = 0x0008, /**< Auto response.           */
	GAIM_MESSAGE_ACTIVE_ONLY = 0x0010,  /**< Hint to the UI that this
	                                        message should not be
	                                        shown in conversations
	                                        which are only open for
	                                        internal UI purposes
	                                        (e.g. for contact-aware
	                                         conversions).           */
	GAIM_MESSAGE_NICK        = 0x0020, /**< Contains your nick.      */
	GAIM_MESSAGE_NO_LOG      = 0x0040, /**< Do not log.              */
	GAIM_MESSAGE_WHISPER     = 0x0080, /**< Whispered message.       */
	GAIM_MESSAGE_ERROR       = 0x0200, /**< Error message.           */
	GAIM_MESSAGE_DELAYED     = 0x0400, /**< Delayed message.         */
	GAIM_MESSAGE_RAW         = 0x0800, /**< "Raw" message - don't
	                                        apply formatting         */
	GAIM_MESSAGE_IMAGES      = 0x1000  /**< Message contains images  */

} GaimMessageFlags;

typedef enum
{
	GAIM_CBFLAGS_NONE          = 0x0000, /**< No flags                     */
	GAIM_CBFLAGS_VOICE         = 0x0001, /**< Voiced user or "Participant" */
	GAIM_CBFLAGS_HALFOP        = 0x0002, /**< Half-op                      */
	GAIM_CBFLAGS_OP            = 0x0004, /**< Channel Op or Moderator      */
	GAIM_CBFLAGS_FOUNDER       = 0x0008, /**< Channel Founder              */
	GAIM_CBFLAGS_TYPING        = 0x0010, /**< Currently typing             */

} GaimConvChatBuddyFlags;

typedef enum
{
	GAIM_DEBUG_ALL = 0,  /**< All debug levels.              */
	GAIM_DEBUG_MISC,     /**< General chatter.               */
	GAIM_DEBUG_INFO,     /**< General operation Information. */
	GAIM_DEBUG_WARNING,  /**< Warnings.                      */
	GAIM_DEBUG_ERROR,    /**< Errors.                        */
	GAIM_DEBUG_FATAL     /**< Fatal errors.                  */

} GaimDebugLevel;

typedef enum {
	GAIM_DESKTOP_ITEM_TYPE_NULL = 0 /* This means its NULL, that is, not
					  * set */,
	GAIM_DESKTOP_ITEM_TYPE_OTHER /* This means it's not one of the below
					 strings types, and you must get the
					 Type attribute. */,

	/* These are the standard compliant types: */
	GAIM_DESKTOP_ITEM_TYPE_APPLICATION,
	GAIM_DESKTOP_ITEM_TYPE_LINK,
	GAIM_DESKTOP_ITEM_TYPE_FSDEVICE,
	GAIM_DESKTOP_ITEM_TYPE_MIME_TYPE,
	GAIM_DESKTOP_ITEM_TYPE_DIRECTORY,
	GAIM_DESKTOP_ITEM_TYPE_SERVICE,
	GAIM_DESKTOP_ITEM_TYPE_SERVICE_TYPE
} GaimDesktopItemType;

typedef enum
{
	GAIM_INPUT_READ  = 1 << 0,  /**< A read condition.  */
	GAIM_INPUT_WRITE = 1 << 1   /**< A write condition. */

} GaimInputCondition;

typedef enum
{
	GAIM_XFER_UNKNOWN = 0,  /**< Unknown file transfer type. */
	GAIM_XFER_SEND,         /**< File sending.               */
	GAIM_XFER_RECEIVE       /**< File receiving.             */

} GaimXferType;

typedef enum
{
	GAIM_XFER_STATUS_UNKNOWN = 0,   /**< Unknown, the xfer may be null. */
	GAIM_XFER_STATUS_NOT_STARTED,   /**< It hasn't started yet. */
	GAIM_XFER_STATUS_ACCEPTED,      /**< Receive accepted, but destination file not selected yet */
	GAIM_XFER_STATUS_STARTED,       /**< gaim_xfer_start has been called. */
	GAIM_XFER_STATUS_DONE,          /**< The xfer completed successfully. */
	GAIM_XFER_STATUS_CANCEL_LOCAL,  /**< The xfer was canceled by us. */
	GAIM_XFER_STATUS_CANCEL_REMOTE  /**< The xfer was canceled by the other end, or we couldn't connect. */
} GaimXferStatusType;

typedef enum {
	GAIM_LOG_IM,
	GAIM_LOG_CHAT,
	GAIM_LOG_SYSTEM
} GaimLogType;

typedef enum {
	GAIM_LOG_READ_NO_NEWLINE = 1
} GaimLogReadFlags;

typedef enum
{
	GAIM_NOTIFY_MESSAGE = 0,   /**< Message notification.         */
	GAIM_NOTIFY_EMAIL,         /**< Single e-mail notification.   */
	GAIM_NOTIFY_EMAILS,        /**< Multiple e-mail notification. */
	GAIM_NOTIFY_FORMATTED,     /**< Formatted text.               */
	GAIM_NOTIFY_SEARCHRESULTS, /**< Buddy search results.         */
	GAIM_NOTIFY_USERINFO,      /**< Formatted userinfo text.      */
	GAIM_NOTIFY_URI            /**< URI notification or display.  */

} GaimNotifyType;

typedef enum
{
	GAIM_NOTIFY_MSG_ERROR   = 0, /**< Error notification.       */
	GAIM_NOTIFY_MSG_WARNING,     /**< Warning notification.     */
	GAIM_NOTIFY_MSG_INFO         /**< Information notification. */

} GaimNotifyMsgType;

typedef enum
{
	GAIM_NOTIFY_BUTTON_LABELED = 0,  /**< special use, see _button_add_labeled */
	GAIM_NOTIFY_BUTTON_CONTINUE = 1,
	GAIM_NOTIFY_BUTTON_ADD,
	GAIM_NOTIFY_BUTTON_INFO,
	GAIM_NOTIFY_BUTTON_IM,
	GAIM_NOTIFY_BUTTON_JOIN,
	GAIM_NOTIFY_BUTTON_INVITE
} GaimNotifySearchButtonType;

typedef enum
{
	GAIM_PLUGIN_UNKNOWN  = -1,  /**< Unknown type.    */
	GAIM_PLUGIN_STANDARD = 0,   /**< Standard plugin. */
	GAIM_PLUGIN_LOADER,         /**< Loader plugin.   */
	GAIM_PLUGIN_PROTOCOL        /**< Protocol plugin. */

} GaimPluginType;

typedef enum
{
	GAIM_STRING_FORMAT_TYPE_NONE      = 0,
	GAIM_STRING_FORMAT_TYPE_MULTILINE = 1 << 0,
	GAIM_STRING_FORMAT_TYPE_HTML      = 1 << 1
} GaimStringFormatType;

typedef enum {
	GAIM_PLUGIN_PREF_NONE,
	GAIM_PLUGIN_PREF_CHOICE,
	GAIM_PLUGIN_PREF_INFO,   /**< no-value label */
	GAIM_PLUGIN_PREF_STRING_FORMAT
} GaimPluginPrefType;

typedef enum
{
	GAIM_POUNCE_NONE             = 0x000, /**< No events.                    */
	GAIM_POUNCE_SIGNON           = 0x001, /**< The buddy signed on.          */
	GAIM_POUNCE_SIGNOFF          = 0x002, /**< The buddy signed off.         */
	GAIM_POUNCE_AWAY             = 0x004, /**< The buddy went away.          */
	GAIM_POUNCE_AWAY_RETURN      = 0x008, /**< The buddy returned from away. */
	GAIM_POUNCE_IDLE             = 0x010, /**< The buddy became idle.        */
	GAIM_POUNCE_IDLE_RETURN      = 0x020, /**< The buddy is no longer idle.  */
	GAIM_POUNCE_TYPING           = 0x040, /**< The buddy started typing.     */
	GAIM_POUNCE_TYPED            = 0x080, /**< The buddy has entered text.   */
	GAIM_POUNCE_TYPING_STOPPED   = 0x100, /**< The buddy stopped typing.     */
	GAIM_POUNCE_MESSAGE_RECEIVED = 0x200  /**< The buddy sent a message      */

} GaimPounceEvent;

typedef enum
{
	GAIM_POUNCE_OPTION_NONE		= 0x00, /**< No Option                */
	GAIM_POUNCE_OPTION_AWAY		= 0x01  /**< Pounce only when away    */
} GaimPounceOption;

typedef enum _GaimPrefType
{
	GAIM_PREF_NONE,
	GAIM_PREF_BOOLEAN,
	GAIM_PREF_INT,
	GAIM_PREF_STRING,
	GAIM_PREF_STRING_LIST

} GaimPrefType;

typedef enum _GaimPrivacyType
{
	GAIM_PRIVACY_ALLOW_ALL = 1,
	GAIM_PRIVACY_DENY_ALL,
	GAIM_PRIVACY_ALLOW_USERS,
	GAIM_PRIVACY_DENY_USERS,
	GAIM_PRIVACY_ALLOW_BUDDYLIST
} GaimPrivacyType;

typedef enum
{
	GAIM_PROXY_USE_GLOBAL = -1,  /**< Use the global proxy information. */
	GAIM_PROXY_NONE = 0,         /**< No proxy.                         */
	GAIM_PROXY_HTTP,             /**< HTTP proxy.                       */
	GAIM_PROXY_SOCKS4,           /**< SOCKS 4 proxy.                    */
	GAIM_PROXY_SOCKS5,           /**< SOCKS 5 proxy.                    */
	GAIM_PROXY_USE_ENVVAR        /**< Use environmental settings.       */

} GaimProxyType;

typedef enum {
	GAIM_ICON_SCALE_DISPLAY = 0x01,		/**< We scale the icon when we display it */
	GAIM_ICON_SCALE_SEND = 0x02			/**< We scale the icon before we send it to the server */
} GaimIconScaleRules;

typedef enum
{
	/**
	 * Use a unique name, not an alias, for chat rooms.
	 *
	 * Jabber lets you choose what name you want for chat.
	 * So it shouldn't be pulling the alias for when you're in chat;
	 * it gets annoying.
	 */
	OPT_PROTO_UNIQUE_CHATNAME = 0x00000004,

	/**
	 * Chat rooms have topics.
	 *
	 * IRC and Jabber support this.
	 */
	OPT_PROTO_CHAT_TOPIC = 0x00000008,

	/**
	 * Don't require passwords for sign-in.
	 *
	 * Zephyr doesn't require passwords, so there's no
	 * need for a password prompt.
	 */
	OPT_PROTO_NO_PASSWORD = 0x00000010,

	/**
	 * Notify on new mail.
	 *
	 * MSN and Yahoo notify you when you have new mail.
	 */
	OPT_PROTO_MAIL_CHECK = 0x00000020,

	/**
	 * Images in IMs.
	 *
	 * Oscar lets you send images in direct IMs.
	 */
	OPT_PROTO_IM_IMAGE = 0x00000040,

	/**
	 * Allow passwords to be optional.
	 *
	 * Passwords in IRC are optional, and are needed for certain
	 * functionality.
	 */
	OPT_PROTO_PASSWORD_OPTIONAL = 0x00000080,

	/**
	 * Allows font size to be specified in sane point size
	 *
	 * Probably just Jabber and Y!M
	 */
	OPT_PROTO_USE_POINTSIZE = 0x00000100,

	/**
	 * Set the Register button active when screenname is not given.
	 *
	 * Gadu-Gadu doesn't need a screenname to register new account.
	 */
	OPT_PROTO_REGISTER_NOSCREENNAME = 0x00000200,

} GaimProtocolOptions;

typedef enum
{
	GAIM_REQUEST_INPUT = 0,  /**< Text input request.        */
	GAIM_REQUEST_CHOICE,     /**< Multiple-choice request.   */
	GAIM_REQUEST_ACTION,     /**< Action request.            */
	GAIM_REQUEST_FIELDS,     /**< Multiple fields request.   */
	GAIM_REQUEST_FILE,       /**< File open or save request. */
	GAIM_REQUEST_FOLDER      /**< Folder selection request.  */

} GaimRequestType;

typedef enum
{
	GAIM_REQUEST_FIELD_NONE,
	GAIM_REQUEST_FIELD_STRING,
	GAIM_REQUEST_FIELD_INTEGER,
	GAIM_REQUEST_FIELD_BOOLEAN,
	GAIM_REQUEST_FIELD_CHOICE,
	GAIM_REQUEST_FIELD_LIST,
	GAIM_REQUEST_FIELD_LABEL,
	GAIM_REQUEST_FIELD_IMAGE,
	GAIM_REQUEST_FIELD_ACCOUNT

} GaimRequestFieldType;

typedef enum
{
	GAIM_ROOMLIST_ROOMTYPE_CATEGORY = 0x01, /**< It's a category, but not a room you can join. */
	GAIM_ROOMLIST_ROOMTYPE_ROOM = 0x02      /**< It's a room, like the kind you can join. */

} GaimRoomlistRoomType;

typedef enum
{
	GAIM_ROOMLIST_FIELD_BOOL,
	GAIM_ROOMLIST_FIELD_INT,
	GAIM_ROOMLIST_FIELD_STRING /**< We do a g_strdup on the passed value if it's this type. */

} GaimRoomlistFieldType;

typedef enum
{
	GAIM_PRESENCE_CONTEXT_UNSET   = 0,
	GAIM_PRESENCE_CONTEXT_ACCOUNT,
	GAIM_PRESENCE_CONTEXT_CONV,
	GAIM_PRESENCE_CONTEXT_BUDDY

} GaimPresenceContext;

typedef enum
{
	GAIM_STATUS_UNSET = 0,
	GAIM_STATUS_OFFLINE,
	GAIM_STATUS_AVAILABLE,
	GAIM_STATUS_UNAVAILABLE,
	GAIM_STATUS_INVISIBLE,
	GAIM_STATUS_AWAY,
	GAIM_STATUS_EXTENDED_AWAY,
	GAIM_STATUS_MOBILE,
	GAIM_STATUS_NUM_PRIMITIVES

} GaimStatusPrimitive;

typedef enum {
	GAIM_STUN_STATUS_UNDISCOVERED = -1,
	GAIM_STUN_STATUS_UNKNOWN, /* no STUN server reachable */
	GAIM_STUN_STATUS_DISCOVERING,
	GAIM_STUN_STATUS_DISCOVERED
} GaimStunStatus;

typedef enum {
	GAIM_STUN_NAT_TYPE_PUBLIC_IP,
	GAIM_STUN_NAT_TYPE_UNKNOWN_NAT,
	GAIM_STUN_NAT_TYPE_FULL_CONE,
	GAIM_STUN_NAT_TYPE_RESTRICTED_CONE,
	GAIM_STUN_NAT_TYPE_PORT_RESTRICTED_CONE,
	GAIM_STUN_NAT_TYPE_SYMMETRIC
} GaimStunNatType;

typedef enum _GaimSoundEventID
{
	GAIM_SOUND_BUDDY_ARRIVE = 0, /**< Buddy signs on.                       */
	GAIM_SOUND_BUDDY_LEAVE,      /**< Buddy signs off.                      */
	GAIM_SOUND_RECEIVE,          /**< Receive an IM.                        */
	GAIM_SOUND_FIRST_RECEIVE,    /**< Receive an IM that starts a conv.     */
	GAIM_SOUND_SEND,             /**< Send an IM.                           */
	GAIM_SOUND_CHAT_JOIN,        /**< Someone joins a chat.                 */
	GAIM_SOUND_CHAT_LEAVE,       /**< Someone leaves a chat.                */
	GAIM_SOUND_CHAT_YOU_SAY,     /**< You say something in a chat.          */
	GAIM_SOUND_CHAT_SAY,         /**< Someone else says somthing in a chat. */
	GAIM_SOUND_POUNCE_DEFAULT,   /**< Default sound for a buddy pounce.     */
	GAIM_SOUND_CHAT_NICK,        /**< Someone says your name in a chat.     */
	GAIM_NUM_SOUNDS              /**< Total number of sounds.               */

} GaimSoundEventID;

typedef enum
{
	GAIM_SSL_HANDSHAKE_FAILED = 1,
	GAIM_SSL_CONNECT_FAILED = 2
} GaimSslErrorType;

typedef enum
{
	GAIM_TYPE_UNKNOWN = 0,  /**< Unknown type.                     */
	GAIM_TYPE_SUBTYPE,      /**< Subtype.                          */
	GAIM_TYPE_CHAR,         /**< Character.                        */
	GAIM_TYPE_UCHAR,        /**< Unsigned character.               */
	GAIM_TYPE_BOOLEAN,      /**< Boolean.                          */
	GAIM_TYPE_SHORT,        /**< Short integer.                    */
	GAIM_TYPE_USHORT,       /**< Unsigned short integer.           */
	GAIM_TYPE_INT,          /**< Integer.                          */
	GAIM_TYPE_UINT,         /**< Unsigned integer.                 */
	GAIM_TYPE_LONG,         /**< Long integer.                     */
	GAIM_TYPE_ULONG,        /**< Unsigned long integer.            */
	GAIM_TYPE_INT64,        /**< 64-bit integer.                   */
	GAIM_TYPE_UINT64,       /**< 64-bit unsigned integer.          */
	GAIM_TYPE_STRING,       /**< String.                           */
	GAIM_TYPE_OBJECT,       /**< Object pointer.                   */
	GAIM_TYPE_POINTER,      /**< Generic pointer.                  */
	GAIM_TYPE_ENUM,         /**< Enum.                             */
	GAIM_TYPE_BOXED         /**< Boxed pointer with specific type. */

} GaimType;

typedef enum
{
	GAIM_SUBTYPE_UNKNOWN = 0,
	GAIM_SUBTYPE_ACCOUNT,
	GAIM_SUBTYPE_BLIST,
	GAIM_SUBTYPE_BLIST_BUDDY,
	GAIM_SUBTYPE_BLIST_GROUP,
	GAIM_SUBTYPE_BLIST_CHAT,
	GAIM_SUBTYPE_BUDDY_ICON,
	GAIM_SUBTYPE_CONNECTION,
	GAIM_SUBTYPE_CONVERSATION,
	GAIM_SUBTYPE_PLUGIN,
	GAIM_SUBTYPE_BLIST_NODE,
	GAIM_SUBTYPE_CIPHER,
	GAIM_SUBTYPE_STATUS,
	GAIM_SUBTYPE_LOG,
	GAIM_SUBTYPE_XFER,
	GAIM_SUBTYPE_SAVEDSTATUS,
	GAIM_SUBTYPE_XMLNODE
} GaimSubType;

typedef enum _XMLNodeType
{
	XMLNODE_TYPE_TAG,		/**< Just a tag */
	XMLNODE_TYPE_ATTRIB,		/**< Has attributes */
	XMLNODE_TYPE_DATA		/**< Has data */
} XMLNodeType;

/* Generated by ./dbus-analyze-functions.py.  Do not edit! */
struct _GaimAccount;
typedef struct _GaimAccount GaimAccount;
GaimAccount* gaim_accounts_find_any(const char *name, const char *protocol) ;
GaimAccount* gaim_accounts_find_connected(const char *name, const char *protocol) ;
struct _GaimBlistNode;
typedef struct _GaimBlistNode GaimBlistNode;
gboolean GAIM_BLIST_NODE_IS_CHAT(const GaimBlistNode *node) ;
gboolean GAIM_BLIST_NODE_IS_BUDDY(const GaimBlistNode *node) ;
gboolean GAIM_BLIST_NODE_IS_CONTACT(const GaimBlistNode *node) ;
gboolean GAIM_BLIST_NODE_IS_GROUP(const GaimBlistNode *node) ;
struct _GaimBuddy;
typedef struct _GaimBuddy GaimBuddy;
gboolean GAIM_BUDDY_IS_ONLINE(const GaimBuddy *buddy) ;
gboolean GAIM_BLIST_NODE_HAS_FLAG(const GaimBlistNode *node, int flags) ;
gboolean GAIM_BLIST_NODE_SHOULD_SAVE(const GaimBlistNode *node) ;
struct _GaimConnection;
typedef struct _GaimConnection GaimConnection;
gboolean GAIM_CONNECTION_IS_CONNECTED(const GaimConnection *connection) ;
gboolean GAIM_CONNECTION_IS_VALID(const GaimConnection *connection) ;
struct _GaimConversation;
typedef struct _GaimConversation GaimConversation;
struct _GaimConvIm;
typedef struct _GaimConvIm GaimConvIm;
GaimConvIm* GAIM_CONV_IM(const GaimConversation *conversation) ;
GaimConvIm* GAIM_CONV_CHAT(const GaimConversation *conversation) ;
GaimAccount* gaim_account_new(const char *username, const char *protocol_id) ;
void gaim_account_destroy(const GaimAccount *account) ;
void gaim_account_connect(const GaimAccount *account) ;
void gaim_account_register(const GaimAccount *account) ;
void gaim_account_disconnect(const GaimAccount *account) ;
void gaim_account_notify_added(const GaimAccount *account, const char *remote_user, const char *id, const char *alias, const char *message) ;
void gaim_account_request_add(const GaimAccount *account, const char *remote_user, const char *id, const char *alias, const char *message) ;
void gaim_account_request_change_password(const GaimAccount *account) ;
void gaim_account_request_change_user_info(const GaimAccount *account) ;
void gaim_account_set_username(const GaimAccount *account, const char *username) ;
void gaim_account_set_password(const GaimAccount *account, const char *password) ;
void gaim_account_set_alias(const GaimAccount *account, const char *alias) ;
void gaim_account_set_user_info(const GaimAccount *account, const char *user_info) ;
void gaim_account_set_buddy_icon(const GaimAccount *account, const char *icon) ;
void gaim_account_set_protocol_id(const GaimAccount *account, const char *protocol_id) ;
void gaim_account_set_connection(const GaimAccount *account, const GaimConnection *gc) ;
void gaim_account_set_remember_password(const GaimAccount *account, gboolean value) ;
void gaim_account_set_check_mail(const GaimAccount *account, gboolean value) ;
void gaim_account_set_enabled(const GaimAccount *account, const char *ui, gboolean value) ;
struct _GaimProxyInfo;
typedef struct _GaimProxyInfo GaimProxyInfo;
void gaim_account_set_proxy_info(const GaimAccount *account, const GaimProxyInfo *info) ;
void gaim_account_set_status_types(const GaimAccount *account, const GList *status_types_NULL) ;
void gaim_account_set_status_list(const GaimAccount *account, const char *status_id, gboolean active, const GList *attrs_NULL) ;
void gaim_account_clear_settings(const GaimAccount *account) ;
void gaim_account_set_int(const GaimAccount *account, const char *name, int value) ;
void gaim_account_set_string(const GaimAccount *account, const char *name, const char *value) ;
void gaim_account_set_bool(const GaimAccount *account, const char *name, gboolean value) ;
void gaim_account_set_ui_int(const GaimAccount *account, const char *ui, const char *name, int value) ;
void gaim_account_set_ui_string(const GaimAccount *account, const char *ui, const char *name, const char *value) ;
void gaim_account_set_ui_bool(const GaimAccount *account, const char *ui, const char *name, gboolean value) ;
gboolean gaim_account_is_connected(const GaimAccount *account) ;
gboolean gaim_account_is_connecting(const GaimAccount *account) ;
gboolean gaim_account_is_disconnected(const GaimAccount *account) ;
char* gaim_account_get_username(const GaimAccount *account) ;
char* gaim_account_get_password(const GaimAccount *account) ;
char* gaim_account_get_alias(const GaimAccount *account) ;
char* gaim_account_get_user_info(const GaimAccount *account) ;
char* gaim_account_get_buddy_icon(const GaimAccount *account) ;
char* gaim_account_get_protocol_id(const GaimAccount *account) ;
char* gaim_account_get_protocol_name(const GaimAccount *account) ;
GaimConnection* gaim_account_get_connection(const GaimAccount *account) ;
gboolean gaim_account_get_remember_password(const GaimAccount *account) ;
gboolean gaim_account_get_check_mail(const GaimAccount *account) ;
gboolean gaim_account_get_enabled(const GaimAccount *account, const char *ui) ;
GaimProxyInfo* gaim_account_get_proxy_info(const GaimAccount *account) ;
struct _GaimStatus;
typedef struct _GaimStatus GaimStatus;
GaimStatus* gaim_account_get_active_status(const GaimAccount *account) ;
GaimStatus* gaim_account_get_status(const GaimAccount *account, const char *status_id) ;
struct _GaimStatusType;
typedef struct _GaimStatusType GaimStatusType;
GaimStatusType* gaim_account_get_status_type(const GaimAccount *account, const char *id) ;
GaimStatusType* gaim_account_get_status_type_with_primitive(const GaimAccount *account, GaimStatusPrimitive primitive) ;
struct _GaimPresence;
typedef struct _GaimPresence GaimPresence;
GaimPresence* gaim_account_get_presence(const GaimAccount *account) ;
gboolean gaim_account_is_status_active(const GaimAccount *account, const char *status_id) ;
GList* gaim_account_get_status_types(const GaimAccount *account) ;
int gaim_account_get_int(const GaimAccount *account, const char *name, int default_value) ;
char* gaim_account_get_string(const GaimAccount *account, const char *name, const char *default_value) ;
gboolean gaim_account_get_bool(const GaimAccount *account, const char *name, gboolean default_value) ;
int gaim_account_get_ui_int(const GaimAccount *account, const char *ui, const char *name, int default_value) ;
char* gaim_account_get_ui_string(const GaimAccount *account, const char *ui, const char *name, const char *default_value) ;
gboolean gaim_account_get_ui_bool(const GaimAccount *account, const char *ui, const char *name, gboolean default_value) ;
struct _GaimLog;
typedef struct _GaimLog GaimLog;
GaimLog* gaim_account_get_log(const GaimAccount *account, gboolean create) ;
void gaim_account_destroy_log(const GaimAccount *account) ;
void gaim_account_add_buddy(const GaimAccount *account, const GaimBuddy *buddy) ;
void gaim_account_add_buddies(const GaimAccount *account, const GList *buddies_NULL) ;
struct _GaimGroup;
typedef struct _GaimGroup GaimGroup;
void gaim_account_remove_buddy(const GaimAccount *account, const GaimBuddy *buddy, const GaimGroup *group) ;
void gaim_account_remove_buddies(const GaimAccount *account, const GList *buddies_NULL, const GList *groups_NULL) ;
void gaim_account_remove_group(const GaimAccount *account, const GaimGroup *group) ;
void gaim_account_change_password(const GaimAccount *account, const char *orig_pw, const char *new_pw) ;
gboolean gaim_account_supports_offline_message(const GaimAccount *account, const GaimBuddy *buddy) ;
void gaim_accounts_add(const GaimAccount *account) ;
void gaim_accounts_remove(const GaimAccount *account) ;
void gaim_accounts_delete(const GaimAccount *account) ;
void gaim_accounts_reorder(const GaimAccount *account, gint new_index) ;
GList* gaim_accounts_get_all() ;
GList* gaim_accounts_get_all_active() ;
GaimAccount* gaim_accounts_find(const char *name, const char *protocol) ;
void gaim_accounts_restore_current_statuses() ;
struct _GaimAccountUiOps;
typedef struct _GaimAccountUiOps GaimAccountUiOps;
void gaim_accounts_set_ui_ops(const GaimAccountUiOps *ops) ;
GaimAccountUiOps* gaim_accounts_get_ui_ops() ;
void gaim_accounts_init() ;
void gaim_accounts_uninit() ;
struct _GaimBuddyList;
typedef struct _GaimBuddyList GaimBuddyList;
GaimBuddyList* gaim_blist_new() ;
void gaim_set_blist(const GaimBuddyList *blist) ;
GaimBuddyList* gaim_get_blist() ;
GaimBlistNode* gaim_blist_get_root() ;
GaimBlistNode* gaim_blist_node_next(const GaimBlistNode *node, gboolean offline) ;
void gaim_blist_show() ;
void gaim_blist_destroy() ;
void gaim_blist_set_visible(gboolean show) ;
void gaim_blist_update_buddy_status(const GaimBuddy *buddy, const GaimStatus *old_status) ;
void gaim_blist_update_buddy_icon(const GaimBuddy *buddy) ;
void gaim_blist_rename_buddy(const GaimBuddy *buddy, const char *name) ;
struct _GaimContact;
typedef struct _GaimContact GaimContact;
void gaim_blist_alias_contact(const GaimContact *contact, const char *alias) ;
void gaim_blist_alias_buddy(const GaimBuddy *buddy, const char *alias) ;
void gaim_blist_server_alias_buddy(const GaimBuddy *buddy, const char *alias) ;
struct _GaimChat;
typedef struct _GaimChat GaimChat;
void gaim_blist_alias_chat(const GaimChat *chat, const char *alias) ;
void gaim_blist_rename_group(const GaimGroup *group, const char *name) ;
GaimChat* gaim_chat_new(const GaimAccount *account, const char *alias, const GHashTable *components) ;
void gaim_blist_add_chat(const GaimChat *chat, const GaimGroup *group, const GaimBlistNode *node) ;
GaimBuddy* gaim_buddy_new(const GaimAccount *account, const char *screenname, const char *alias) ;
struct _GaimBuddyIcon;
typedef struct _GaimBuddyIcon GaimBuddyIcon;
void gaim_buddy_set_icon(const GaimBuddy *buddy, const GaimBuddyIcon *icon) ;
GaimAccount* gaim_buddy_get_account(const GaimBuddy *buddy) ;
char* gaim_buddy_get_name(const GaimBuddy *buddy) ;
GaimBuddyIcon* gaim_buddy_get_icon(const GaimBuddy *buddy) ;
GaimContact* gaim_buddy_get_contact(const GaimBuddy *buddy) ;
GaimPresence* gaim_buddy_get_presence(const GaimBuddy *buddy) ;
void gaim_blist_add_buddy(const GaimBuddy *buddy, const GaimContact *contact, const GaimGroup *group, const GaimBlistNode *node) ;
GaimGroup* gaim_group_new(const char *name) ;
void gaim_blist_add_group(const GaimGroup *group, const GaimBlistNode *node) ;
GaimContact* gaim_contact_new() ;
void gaim_blist_add_contact(const GaimContact *contact, const GaimGroup *group, const GaimBlistNode *node) ;
void gaim_blist_merge_contact(const GaimContact *source, const GaimBlistNode *node) ;
GaimBuddy* gaim_contact_get_priority_buddy(const GaimContact *contact) ;
void gaim_contact_set_alias(const GaimContact *contact, const char *alias) ;
char* gaim_contact_get_alias(const GaimContact *contact) ;
gboolean gaim_contact_on_account(const GaimContact *contact, const GaimAccount *account) ;
void gaim_contact_invalidate_priority_buddy(const GaimContact *contact) ;
void gaim_blist_remove_buddy(const GaimBuddy *buddy) ;
void gaim_blist_remove_contact(const GaimContact *contact) ;
void gaim_blist_remove_chat(const GaimChat *chat) ;
void gaim_blist_remove_group(const GaimGroup *group) ;
char* gaim_buddy_get_alias_only(const GaimBuddy *buddy) ;
char* gaim_buddy_get_server_alias(const GaimBuddy *buddy) ;
char* gaim_buddy_get_contact_alias(const GaimBuddy *buddy) ;
char* gaim_buddy_get_local_alias(const GaimBuddy *buddy) ;
char* gaim_buddy_get_alias(const GaimBuddy *buddy) ;
char* gaim_chat_get_name(const GaimChat *chat) ;
GaimBuddy* gaim_find_buddy(const GaimAccount *account, const char *name) ;
GaimBuddy* gaim_find_buddy_in_group(const GaimAccount *account, const char *name, const GaimGroup *group) ;
GSList* gaim_find_buddies(const GaimAccount *account, const char *name) ;
GaimGroup* gaim_find_group(const char *name) ;
GaimChat* gaim_blist_find_chat(const GaimAccount *account, const char *name) ;
GaimGroup* gaim_chat_get_group(const GaimChat *chat) ;
GaimGroup* gaim_buddy_get_group(const GaimBuddy *buddy) ;
GSList* gaim_group_get_accounts(const GaimGroup *g) ;
gboolean gaim_group_on_account(const GaimGroup *g, const GaimAccount *account) ;
void gaim_blist_add_account(const GaimAccount *account) ;
void gaim_blist_remove_account(const GaimAccount *account) ;
int gaim_blist_get_group_size(const GaimGroup *group, gboolean offline) ;
int gaim_blist_get_group_online_count(const GaimGroup *group) ;
void gaim_blist_load() ;
void gaim_blist_schedule_save() ;
void gaim_blist_request_add_buddy(const GaimAccount *account, const char *username, const char *group, const char *alias) ;
void gaim_blist_request_add_chat(const GaimAccount *account, const GaimGroup *group, const char *alias, const char *name) ;
void gaim_blist_request_add_group() ;
void gaim_blist_node_set_bool(const GaimBlistNode *node, const char *key, gboolean value) ;
gboolean gaim_blist_node_get_bool(const GaimBlistNode *node, const char *key) ;
void gaim_blist_node_set_int(const GaimBlistNode *node, const char *key, int value) ;
int gaim_blist_node_get_int(const GaimBlistNode *node, const char *key) ;
void gaim_blist_node_set_string(const GaimBlistNode *node, const char *key, const char *value) ;
char* gaim_blist_node_get_string(const GaimBlistNode *node, const char *key) ;
void gaim_blist_node_remove_setting(const GaimBlistNode *node, const char *key) ;
void gaim_blist_node_set_flags(const GaimBlistNode *node, GaimBlistNodeFlags flags) ;
GaimBlistNodeFlags gaim_blist_node_get_flags(const GaimBlistNode *node) ;
GList* gaim_blist_node_get_extended_menu(const GaimBlistNode *n) ;
struct _GaimBlistUiOps;
typedef struct _GaimBlistUiOps GaimBlistUiOps;
void gaim_blist_set_ui_ops(const GaimBlistUiOps *ops) ;
GaimBlistUiOps* gaim_blist_get_ui_ops() ;
void gaim_blist_init() ;
void gaim_blist_uninit() ;
void gaim_buddy_icon_destroy(const GaimBuddyIcon *icon) ;
GaimBuddyIcon* gaim_buddy_icon_ref(const GaimBuddyIcon *icon) ;
GaimBuddyIcon* gaim_buddy_icon_unref(const GaimBuddyIcon *icon) ;
void gaim_buddy_icon_update(const GaimBuddyIcon *icon) ;
void gaim_buddy_icon_cache(const GaimBuddyIcon *icon, const GaimBuddy *buddy) ;
void gaim_buddy_icon_uncache(const GaimBuddy *buddy) ;
void gaim_buddy_icon_set_account(const GaimBuddyIcon *icon, const GaimAccount *account) ;
void gaim_buddy_icon_set_username(const GaimBuddyIcon *icon, const char *username) ;
GaimAccount* gaim_buddy_icon_get_account(const GaimBuddyIcon *icon) ;
char* gaim_buddy_icon_get_username(const GaimBuddyIcon *icon) ;
char* gaim_buddy_icon_get_type(const GaimBuddyIcon *icon) ;
GaimBuddyIcon* gaim_buddy_icons_find(const GaimAccount *account, const char *username) ;
void gaim_buddy_icons_set_caching(gboolean caching) ;
gboolean gaim_buddy_icons_is_caching() ;
void gaim_buddy_icons_set_cache_dir(const char *cache_dir) ;
char* gaim_buddy_icons_get_cache_dir() ;
char* gaim_buddy_icons_get_full_path(const char *icon) ;
void gaim_buddy_icons_init() ;
void gaim_buddy_icons_uninit() ;
struct _GaimBuddyIconSpec;
typedef struct _GaimBuddyIconSpec GaimBuddyIconSpec;
void gaim_buddy_icon_get_scale_size(const GaimBuddyIconSpec *spec, const int *width_NULL, const int *height_NULL) ;
void gaim_connection_new(const GaimAccount *account, gboolean regist, const char *password) ;
void gaim_connection_destroy(const GaimConnection *gc) ;
void gaim_connection_set_state(const GaimConnection *gc, GaimConnectionState state) ;
void gaim_connection_set_account(const GaimConnection *gc, const GaimAccount *account) ;
void gaim_connection_set_display_name(const GaimConnection *gc, const char *name) ;
GaimConnectionState gaim_connection_get_state(const GaimConnection *gc) ;
GaimAccount* gaim_connection_get_account(const GaimConnection *gc) ;
char* gaim_connection_get_password(const GaimConnection *gc) ;
char* gaim_connection_get_display_name(const GaimConnection *gc) ;
void gaim_connection_notice(const GaimConnection *gc, const char *text) ;
void gaim_connection_error(const GaimConnection *gc, const char *reason) ;
void gaim_connections_disconnect_all() ;
GList* gaim_connections_get_all() ;
GList* gaim_connections_get_connecting() ;
struct _GaimConnectionUiOps;
typedef struct _GaimConnectionUiOps GaimConnectionUiOps;
void gaim_connections_set_ui_ops(const GaimConnectionUiOps *ops) ;
GaimConnectionUiOps* gaim_connections_get_ui_ops() ;
void gaim_connections_init() ;
void gaim_connections_uninit() ;
GaimConversation* gaim_conversation_new(GaimConversationType type, const GaimAccount *account, const char *name) ;
void gaim_conversation_destroy(const GaimConversation *conv) ;
void gaim_conversation_present(const GaimConversation *conv) ;
GaimConversationType gaim_conversation_get_type(const GaimConversation *conv) ;
struct _GaimConversationUiOps;
typedef struct _GaimConversationUiOps GaimConversationUiOps;
void gaim_conversation_set_ui_ops(const GaimConversation *conv, const GaimConversationUiOps *ops) ;
void gaim_conversations_set_ui_ops(const GaimConversationUiOps *ops) ;
GaimConversationUiOps* gaim_conversation_get_ui_ops(const GaimConversation *conv) ;
void gaim_conversation_set_account(const GaimConversation *conv, const GaimAccount *account) ;
GaimAccount* gaim_conversation_get_account(const GaimConversation *conv) ;
GaimConnection* gaim_conversation_get_gc(const GaimConversation *conv) ;
void gaim_conversation_set_title(const GaimConversation *conv, const char *title) ;
char* gaim_conversation_get_title(const GaimConversation *conv) ;
void gaim_conversation_autoset_title(const GaimConversation *conv) ;
void gaim_conversation_set_name(const GaimConversation *conv, const char *name) ;
char* gaim_conversation_get_name(const GaimConversation *conv) ;
void gaim_conversation_set_logging(const GaimConversation *conv, gboolean log) ;
gboolean gaim_conversation_is_logging(const GaimConversation *conv) ;
GaimConvIm* gaim_conversation_get_im_data(const GaimConversation *conv) ;
struct _GaimConvChat;
typedef struct _GaimConvChat GaimConvChat;
GaimConvChat* gaim_conversation_get_chat_data(const GaimConversation *conv) ;
GList* gaim_get_conversations() ;
GList* gaim_get_ims() ;
GList* gaim_get_chats() ;
GaimConversation* gaim_find_conversation_with_account(GaimConversationType type, const char *name, const GaimAccount *account) ;
void gaim_conversation_set_features(const GaimConversation *conv, GaimConnectionFlags features) ;
GaimConnectionFlags gaim_conversation_get_features(const GaimConversation *conv) ;
gboolean gaim_conversation_has_focus(const GaimConversation *conv) ;
void gaim_conversation_update(const GaimConversation *conv, GaimConvUpdateType type) ;
GaimConversation* gaim_conv_im_get_conversation(const GaimConvIm *im) ;
void gaim_conv_im_set_icon(const GaimConvIm *im, const GaimBuddyIcon *icon) ;
GaimBuddyIcon* gaim_conv_im_get_icon(const GaimConvIm *im) ;
void gaim_conv_im_set_typing_state(const GaimConvIm *im, GaimTypingState state) ;
GaimTypingState gaim_conv_im_get_typing_state(const GaimConvIm *im) ;
void gaim_conv_im_start_typing_timeout(const GaimConvIm *im, int timeout) ;
void gaim_conv_im_stop_typing_timeout(const GaimConvIm *im) ;
guint gaim_conv_im_get_typing_timeout(const GaimConvIm *im) ;
void gaim_conv_im_start_send_typed_timeout(const GaimConvIm *im) ;
void gaim_conv_im_stop_send_typed_timeout(const GaimConvIm *im) ;
guint gaim_conv_im_get_send_typed_timeout(const GaimConvIm *im) ;
void gaim_conv_im_update_typing(const GaimConvIm *im) ;
gboolean gaim_conv_present_error(const char *who, const GaimAccount *account, const char *what) ;
void gaim_conv_im_send(const GaimConvIm *im, const char *message) ;
void gaim_conv_send_confirm(const GaimConversation *conv, const char *message) ;
void gaim_conv_im_send_with_flags(const GaimConvIm *im, const char *message, GaimMessageFlags flags) ;
gboolean gaim_conv_custom_smiley_add(const GaimConversation *conv, const char *smile, const char *cksum_type, const char *chksum, gboolean remote) ;
void gaim_conv_custom_smiley_close(const GaimConversation *conv, const char *smile) ;
GaimConversation* gaim_conv_chat_get_conversation(const GaimConvChat *chat) ;
GList* gaim_conv_chat_set_users(const GaimConvChat *chat, const GList *users_NULL) ;
GList* gaim_conv_chat_get_users(const GaimConvChat *chat) ;
void gaim_conv_chat_ignore(const GaimConvChat *chat, const char *name) ;
void gaim_conv_chat_unignore(const GaimConvChat *chat, const char *name) ;
GList* gaim_conv_chat_set_ignored(const GaimConvChat *chat, const GList *ignored_NULL) ;
GList* gaim_conv_chat_get_ignored(const GaimConvChat *chat) ;
char* gaim_conv_chat_get_ignored_user(const GaimConvChat *chat, const char *user) ;
gboolean gaim_conv_chat_is_user_ignored(const GaimConvChat *chat, const char *user) ;
void gaim_conv_chat_set_topic(const GaimConvChat *chat, const char *who, const char *topic) ;
char* gaim_conv_chat_get_topic(const GaimConvChat *chat) ;
void gaim_conv_chat_set_id(const GaimConvChat *chat, int id) ;
int gaim_conv_chat_get_id(const GaimConvChat *chat) ;
void gaim_conv_chat_send(const GaimConvChat *chat, const char *message) ;
void gaim_conv_chat_send_with_flags(const GaimConvChat *chat, const char *message, GaimMessageFlags flags) ;
void gaim_conv_chat_add_user(const GaimConvChat *chat, const char *user, const char *extra_msg, GaimConvChatBuddyFlags flags, gboolean new_arrival) ;
void gaim_conv_chat_add_users(const GaimConvChat *chat, const GList *users_NULL, const GList *extra_msgs_NULL, const GList *flags_NULL, gboolean new_arrivals) ;
void gaim_conv_chat_rename_user(const GaimConvChat *chat, const char *old_user, const char *new_user) ;
void gaim_conv_chat_remove_user(const GaimConvChat *chat, const char *user, const char *reason) ;
void gaim_conv_chat_remove_users(const GaimConvChat *chat, const GList *users_NULL, const char *reason) ;
gboolean gaim_conv_chat_find_user(const GaimConvChat *chat, const char *user) ;
void gaim_conv_chat_user_set_flags(const GaimConvChat *chat, const char *user, GaimConvChatBuddyFlags flags) ;
GaimConvChatBuddyFlags gaim_conv_chat_user_get_flags(const GaimConvChat *chat, const char *user) ;
void gaim_conv_chat_clear_users(const GaimConvChat *chat) ;
void gaim_conv_chat_set_nick(const GaimConvChat *chat, const char *nick) ;
char* gaim_conv_chat_get_nick(const GaimConvChat *chat) ;
GaimConversation* gaim_find_chat(const GaimConnection *gc, int id) ;
void gaim_conv_chat_left(const GaimConvChat *chat) ;
gboolean gaim_conv_chat_has_left(const GaimConvChat *chat) ;
struct _GaimConvChatBuddy;
typedef struct _GaimConvChatBuddy GaimConvChatBuddy;
GaimConvChatBuddy* gaim_conv_chat_cb_new(const char *name, const char *alias, GaimConvChatBuddyFlags flags) ;
GaimConvChatBuddy* gaim_conv_chat_cb_find(const GaimConvChat *chat, const char *name) ;
char* gaim_conv_chat_cb_get_name(const GaimConvChatBuddy *cb) ;
void gaim_conv_chat_cb_destroy(const GaimConvChatBuddy *cb) ;
void gaim_conversations_init() ;
void gaim_conversations_uninit() ;
gboolean gaim_core_init(const char *ui) ;
void gaim_core_quit() ;
char* gaim_core_get_version() ;
char* gaim_core_get_ui() ;
struct _GaimCore;
typedef struct _GaimCore GaimCore;
GaimCore* gaim_get_core() ;
struct _GaimCoreUiOps;
typedef struct _GaimCoreUiOps GaimCoreUiOps;
void gaim_core_set_ui_ops(const GaimCoreUiOps *ops) ;
GaimCoreUiOps* gaim_core_get_ui_ops() ;
void gaim_log_free(const GaimLog *log) ;
GList* gaim_log_get_logs(GaimLogType type, const char *name, const GaimAccount *account) ;
GList* gaim_log_get_system_logs(const GaimAccount *account) ;
int gaim_log_get_size(const GaimLog *log) ;
int gaim_log_get_total_size(GaimLogType type, const char *name, const GaimAccount *account) ;
char* gaim_log_get_log_dir(GaimLogType type, const char *name, const GaimAccount *account) ;
struct _GaimLogSet;
typedef struct _GaimLogSet GaimLogSet;
void gaim_log_set_free(const GaimLogSet *set) ;
void gaim_log_common_writer(const GaimLog *log, const char *ext) ;
struct _GaimLogLogger;
typedef struct _GaimLogLogger GaimLogLogger;
GList* gaim_log_common_lister(GaimLogType type, const char *name, const GaimAccount *account, const char *ext, const GaimLogLogger *logger) ;
int gaim_log_common_total_sizer(GaimLogType type, const char *name, const GaimAccount *account, const char *ext) ;
int gaim_log_common_sizer(const GaimLog *log) ;
void gaim_log_logger_free(const GaimLogLogger *logger) ;
void gaim_log_logger_add(const GaimLogLogger *logger) ;
void gaim_log_logger_remove(const GaimLogLogger *logger) ;
void gaim_log_logger_set(const GaimLogLogger *logger) ;
GaimLogLogger* gaim_log_logger_get() ;
GList* gaim_log_logger_get_options() ;
void gaim_log_init() ;
void gaim_log_uninit() ;
void gaim_roomlist_show_with_account(const GaimAccount *account) ;
struct _GaimRoomlist;
typedef struct _GaimRoomlist GaimRoomlist;
GaimRoomlist* gaim_roomlist_new(const GaimAccount *account) ;
void gaim_roomlist_ref(const GaimRoomlist *list) ;
void gaim_roomlist_unref(const GaimRoomlist *list) ;
void gaim_roomlist_set_fields(const GaimRoomlist *list, const GList *fields_NULL) ;
void gaim_roomlist_set_in_progress(const GaimRoomlist *list, gboolean in_progress) ;
gboolean gaim_roomlist_get_in_progress(const GaimRoomlist *list) ;
struct _GaimRoomlistRoom;
typedef struct _GaimRoomlistRoom GaimRoomlistRoom;
void gaim_roomlist_room_add(const GaimRoomlist *list, const GaimRoomlistRoom *room) ;
GaimRoomlist* gaim_roomlist_get_list(const GaimConnection *gc) ;
void gaim_roomlist_cancel_get_list(const GaimRoomlist *list) ;
void gaim_roomlist_expand_category(const GaimRoomlist *list, const GaimRoomlistRoom *category) ;
GaimRoomlistRoom* gaim_roomlist_room_new(GaimRoomlistRoomType type, const gchar *name_NULL, const GaimRoomlistRoom *parent) ;
void gaim_roomlist_room_join(const GaimRoomlist *list, const GaimRoomlistRoom *room) ;
struct _GaimRoomlistField;
typedef struct _GaimRoomlistField GaimRoomlistField;
GaimRoomlistField* gaim_roomlist_field_new(GaimRoomlistFieldType type, const gchar *label_NULL, const gchar *name_NULL, gboolean hidden) ;
struct _GaimRoomlistUiOps;
typedef struct _GaimRoomlistUiOps GaimRoomlistUiOps;
void gaim_roomlist_set_ui_ops(const GaimRoomlistUiOps *ops) ;
GaimRoomlistUiOps* gaim_roomlist_get_ui_ops() ;
struct _GaimSavedStatus;
typedef struct _GaimSavedStatus GaimSavedStatus;
GaimSavedStatus* gaim_savedstatus_new(const char *title, GaimStatusPrimitive type) ;
void gaim_savedstatus_set_title(const GaimSavedStatus *status, const char *title) ;
void gaim_savedstatus_set_type(const GaimSavedStatus *status, GaimStatusPrimitive type) ;
void gaim_savedstatus_set_message(const GaimSavedStatus *status, const char *message) ;
void gaim_savedstatus_set_substatus(const GaimSavedStatus *status, const GaimAccount *account, const GaimStatusType *type, const char *message) ;
void gaim_savedstatus_unset_substatus(const GaimSavedStatus *saved_status, const GaimAccount *account) ;
gboolean gaim_savedstatus_delete(const char *title) ;
GList* gaim_savedstatuses_get_all() ;
GaimSavedStatus* gaim_savedstatus_get_current() ;
GaimSavedStatus* gaim_savedstatus_get_default() ;
GaimSavedStatus* gaim_savedstatus_get_idleaway() ;
gboolean gaim_savedstatus_is_idleaway() ;
void gaim_savedstatus_set_idleaway(gboolean idleaway) ;
GaimSavedStatus* gaim_savedstatus_get_startup() ;
GaimSavedStatus* gaim_savedstatus_find(const char *title) ;
GaimSavedStatus* gaim_savedstatus_find_transient_by_type_and_message(GaimStatusPrimitive type, const char *message) ;
gboolean gaim_savedstatus_is_transient(const GaimSavedStatus *saved_status) ;
char* gaim_savedstatus_get_title(const GaimSavedStatus *saved_status) ;
GaimStatusPrimitive gaim_savedstatus_get_type(const GaimSavedStatus *saved_status) ;
char* gaim_savedstatus_get_message(const GaimSavedStatus *saved_status) ;
gboolean gaim_savedstatus_has_substatuses(const GaimSavedStatus *saved_status) ;
struct _GaimSavedStatusSub;
typedef struct _GaimSavedStatusSub GaimSavedStatusSub;
GaimSavedStatusSub* gaim_savedstatus_get_substatus(const GaimSavedStatus *saved_status, const GaimAccount *account) ;
GaimStatusType* gaim_savedstatus_substatus_get_type(const GaimSavedStatusSub *substatus) ;
char* gaim_savedstatus_substatus_get_message(const GaimSavedStatusSub *substatus) ;
void gaim_savedstatus_activate(const GaimSavedStatus *saved_status) ;
void gaim_savedstatus_activate_for_account(const GaimSavedStatus *saved_status, const GaimAccount *account) ;
void gaim_savedstatuses_init() ;
void gaim_savedstatuses_uninit() ;
char* gaim_primitive_get_id_from_type(GaimStatusPrimitive type) ;
char* gaim_primitive_get_name_from_type(GaimStatusPrimitive type) ;
GaimStatusPrimitive gaim_primitive_get_type_from_id(const char *id) ;
GaimStatusType* gaim_status_type_new_full(GaimStatusPrimitive primitive, const char *id, const char *name, gboolean saveable, gboolean user_settable, gboolean independent) ;
GaimStatusType* gaim_status_type_new(GaimStatusPrimitive primitive, const char *id, const char *name, gboolean user_settable) ;
struct _GaimValue;
typedef struct _GaimValue GaimValue;
void gaim_status_type_destroy(const GaimStatusType *status_type) ;
void gaim_status_type_set_primary_attr(const GaimStatusType *status_type, const char *attr_id) ;
void gaim_status_type_add_attr(const GaimStatusType *status_type, const char *id, const char *name, const GaimValue *value) ;
GaimStatusPrimitive gaim_status_type_get_primitive(const GaimStatusType *status_type) ;
char* gaim_status_type_get_id(const GaimStatusType *status_type) ;
char* gaim_status_type_get_name(const GaimStatusType *status_type) ;
gboolean gaim_status_type_is_saveable(const GaimStatusType *status_type) ;
gboolean gaim_status_type_is_user_settable(const GaimStatusType *status_type) ;
gboolean gaim_status_type_is_independent(const GaimStatusType *status_type) ;
gboolean gaim_status_type_is_exclusive(const GaimStatusType *status_type) ;
gboolean gaim_status_type_is_available(const GaimStatusType *status_type) ;
char* gaim_status_type_get_primary_attr(const GaimStatusType *type) ;
struct _GaimStatusAttr;
typedef struct _GaimStatusAttr GaimStatusAttr;
GaimStatusAttr* gaim_status_type_get_attr(const GaimStatusType *status_type, const char *id) ;
GList* gaim_status_type_get_attrs(const GaimStatusType *status_type) ;
GaimStatusType* gaim_status_type_find_with_id(const GList *status_types_NULL, const char *id) ;
GaimStatusAttr* gaim_status_attr_new(const char *id, const char *name, const GaimValue *value_type) ;
void gaim_status_attr_destroy(const GaimStatusAttr *attr) ;
char* gaim_status_attr_get_id(const GaimStatusAttr *attr) ;
char* gaim_status_attr_get_name(const GaimStatusAttr *attr) ;
GaimValue* gaim_status_attr_get_value(const GaimStatusAttr *attr) ;
GaimStatus* gaim_status_new(const GaimStatusType *status_type, const GaimPresence *presence) ;
void gaim_status_destroy(const GaimStatus *status) ;
void gaim_status_set_active(const GaimStatus *status, gboolean active) ;
void gaim_status_set_active_with_attrs_list(const GaimStatus *status, gboolean active, const GList *attrs_NULL) ;
void gaim_status_set_attr_boolean(const GaimStatus *status, const char *id, gboolean value) ;
void gaim_status_set_attr_int(const GaimStatus *status, const char *id, int value) ;
void gaim_status_set_attr_string(const GaimStatus *status, const char *id, const char *value) ;
GaimStatusType* gaim_status_get_type(const GaimStatus *status) ;
GaimPresence* gaim_status_get_presence(const GaimStatus *status) ;
char* gaim_status_get_id(const GaimStatus *status) ;
char* gaim_status_get_name(const GaimStatus *status) ;
gboolean gaim_status_is_independent(const GaimStatus *status) ;
gboolean gaim_status_is_exclusive(const GaimStatus *status) ;
gboolean gaim_status_is_available(const GaimStatus *status) ;
gboolean gaim_status_is_active(const GaimStatus *status) ;
gboolean gaim_status_is_online(const GaimStatus *status) ;
GaimValue* gaim_status_get_attr_value(const GaimStatus *status, const char *id) ;
gboolean gaim_status_get_attr_boolean(const GaimStatus *status, const char *id) ;
int gaim_status_get_attr_int(const GaimStatus *status, const char *id) ;
char* gaim_status_get_attr_string(const GaimStatus *status, const char *id) ;
gint gaim_status_compare(const GaimStatus *status1, const GaimStatus *status2) ;
GaimPresence* gaim_presence_new(GaimPresenceContext context) ;
GaimPresence* gaim_presence_new_for_account(const GaimAccount *account) ;
GaimPresence* gaim_presence_new_for_conv(const GaimConversation *conv) ;
GaimPresence* gaim_presence_new_for_buddy(const GaimBuddy *buddy) ;
void gaim_presence_destroy(const GaimPresence *presence) ;
void gaim_presence_remove_buddy(const GaimPresence *presence, const GaimBuddy *buddy) ;
void gaim_presence_add_status(const GaimPresence *presence, const GaimStatus *status) ;
void gaim_presence_set_status_active(const GaimPresence *presence, const char *status_id, gboolean active) ;
void gaim_presence_switch_status(const GaimPresence *presence, const char *status_id) ;
GaimPresenceContext gaim_presence_get_context(const GaimPresence *presence) ;
GaimAccount* gaim_presence_get_account(const GaimPresence *presence) ;
GaimConversation* gaim_presence_get_conversation(const GaimPresence *presence) ;
char* gaim_presence_get_chat_user(const GaimPresence *presence) ;
GList* gaim_presence_get_buddies(const GaimPresence *presence) ;
GList* gaim_presence_get_statuses(const GaimPresence *presence) ;
GaimStatus* gaim_presence_get_status(const GaimPresence *presence, const char *status_id) ;
GaimStatus* gaim_presence_get_active_status(const GaimPresence *presence) ;
gboolean gaim_presence_is_available(const GaimPresence *presence) ;
gboolean gaim_presence_is_online(const GaimPresence *presence) ;
gboolean gaim_presence_is_status_active(const GaimPresence *presence, const char *status_id) ;
gboolean gaim_presence_is_status_primitive_active(const GaimPresence *presence, GaimStatusPrimitive primitive) ;
gboolean gaim_presence_is_idle(const GaimPresence *presence) ;
gint gaim_presence_compare(const GaimPresence *presence1, const GaimPresence *presence2) ;
void gaim_status_init() ;
void gaim_status_uninit() ;
void serv_move_buddy(const GaimBuddy *param0, const GaimGroup *param1, const GaimGroup *param2) ;
int serv_send_im(const GaimConnection *param0, const char *param1, const char *param2, GaimMessageFlags flags) ;
void serv_get_info(const GaimConnection *param0, const char *param1) ;
void serv_set_info(const GaimConnection *param0, const char *param1) ;
void serv_add_permit(const GaimConnection *param0, const char *param1) ;
void serv_add_deny(const GaimConnection *param0, const char *param1) ;
void serv_rem_permit(const GaimConnection *param0, const char *param1) ;
void serv_rem_deny(const GaimConnection *param0, const char *param1) ;
void serv_set_permit_deny(const GaimConnection *param0) ;
void serv_join_chat(const GaimConnection *param0, const GHashTable *param1) ;
void serv_reject_chat(const GaimConnection *param0, const GHashTable *param1) ;
void serv_chat_invite(const GaimConnection *param0, int param1, const char *param2, const char *param3) ;
void serv_chat_leave(const GaimConnection *param0, int param1) ;
void serv_chat_whisper(const GaimConnection *param0, int param1, const char *param2, const char *param3) ;
int serv_chat_send(const GaimConnection *param0, int param1, const char *param2, GaimMessageFlags flags) ;
void serv_alias_buddy(const GaimBuddy *param0) ;
void serv_got_alias(const GaimConnection *gc, const char *who, const char *alias) ;
void serv_got_typing(const GaimConnection *gc, const char *name, int timeout, GaimTypingState state) ;
void serv_got_typing_stopped(const GaimConnection *gc, const char *name) ;
void serv_set_buddyicon(const GaimConnection *gc, const char *filename) ;
void serv_got_chat_invite(const GaimConnection *gc, const char *name, const char *who, const char *message, const GHashTable *data) ;
GaimConversation* serv_got_joined_chat(const GaimConnection *gc, int id, const char *name) ;
void serv_got_chat_left(const GaimConnection *g, int id) ;
void serv_send_file(const GaimConnection *gc, const char *who, const char *file) ;
struct _xmlnode;
typedef struct _xmlnode xmlnode;
void xmlnode_insert_child(const xmlnode *parent, const xmlnode *child) ;
char* xmlnode_get_data(const xmlnode *node) ;
void xmlnode_set_attrib(const xmlnode *node, const char *attr, const char *value) ;
char* xmlnode_get_attrib(const xmlnode *node, const char *attr) ;
void xmlnode_remove_attrib(const xmlnode *node, const char *attr) ;
void xmlnode_set_namespace(const xmlnode *node, const char *xmlns) ;
char* xmlnode_get_namespace(const xmlnode *node) ;
char* xmlnode_to_str(const xmlnode *node, const int *len_NULL) ;
char* xmlnode_to_formatted_str(const xmlnode *node, const int *len_NULL) ;
void xmlnode_free(const xmlnode *node) ;
